/*
	This file is part of lgob.

	lgob is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgob is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgob.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2009 Lucas Hermann Negri
*/

#ifndef LGOB_GOBJECT_BOXED
#define LGOB_GOBJECT_BOXED

#include "lgob.h"

int lgob_boxed_new(lua_State* L);

/**
 * Makes a copy of the GBoxed and manage it.
 * 
 * @param L lua_State to use
 * @param type Type of the GBoxed
 * @param pointer Pointer to the GBoxed
 * @return TRUE, if suceeded
 */
gboolean priv_boxed_new(lua_State* L, GType type, gpointer pointer);

/**
 * Just ref to a GBoxed, doesn't manages the memory.
 * 
 * @param L lua_State to use
 * @param type Type of the GBoxed
 * @param pointer Pointer to the GBoxed
 * @return TRUE, if suceeded
 */
gboolean priv_boxed_new_no_copy(lua_State* L, GType type, gpointer pointer);

#endif
