/*
	This file is part of lgob.

	lgob is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgob is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgob.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2009 Lucas Hermann Negri
*/

#include "object.h"

int lgob_timeout_idle_add(lua_State* L);
int lgob_timeout_add(lua_State* L);
int lgob_timeout_remove(lua_State* L);

int lgob_main_loop_new(lua_State* L);
int lgob_main_loop_run(lua_State* L);
int lgob_main_loop_iterate(lua_State* L);
int lgob_main_loop_pending(lua_State* L);
int lgob_main_loop_quit(lua_State* L);
int lgob_main_loop_free(lua_State* L);

#if GLIB_MINOR_VERSION >= 8

int lgob_environment_get_host_name(lua_State* L);

#endif

#if GLIB_MINOR_VERSION >= 10

int lgob_date_set_time_t(lua_State* L);

#endif

#if GLIB_MINOR_VERSION >= 12

int lgob_base64_encode(lua_State* L);
int lgob_base64_decode(lua_State* L);
int lgob_time_val_from_iso8601(lua_State* L);
int lgob_time_val_to_iso8601(lua_State* L);

#endif

#if GLIB_MINOR_VERSION >= 16

int lgob_checksum_get_md5(lua_State* L);
int lgob_checksum_get_sha1(lua_State* L);
int lgob_checksum_get_sha256(lua_State* L);

#endif

int lgob_environment_get_user_name(lua_State* L);
int lgob_environment_get_real_name(lua_State* L);
int lgob_environment_get_user_data_dir(lua_State* L);
int lgob_environment_get_user_cache_dir(lua_State* L);
int lgob_environment_get_user_config_dir(lua_State* L);
int lgob_environment_get_tmp_dir(lua_State* L);
int lgob_environment_get_current_dir(lua_State* L);
int lgob_environment_get_home_dir(lua_State* L);

int lgob_path_is_absolute(lua_State* L);
int lgob_path_skip_root(lua_State* L);
int lgob_path_get_basename(lua_State* L);
int lgob_path_get_dirname(lua_State* L);
int lgob_path_find_program(lua_State* L);

int lgob_date_new(lua_State* L);
int lgob_date_free(lua_State* L);
int lgob_date_set_dmy(lua_State* L);
int lgob_date_set_julian(lua_State* L);
int lgob_date_set_parse(lua_State* L);
int lgob_date_is_leap_year(lua_State* L);
int lgob_date_compare(lua_State* L);
int lgob_date_valid(lua_State* L);
int lgob_date_get_day(lua_State* L);
int lgob_date_get_month(lua_State* L);
int lgob_date_get_year(lua_State* L);

int lgob_rand_free(lua_State* L);
int lgob_rand_new(lua_State* L);
int lgob_rand_set_seed(lua_State* L);
int lgob_rand_boolean(lua_State* L);
int lgob_rand_int(lua_State* L);
int lgob_rand_double(lua_State* L);

int lgob_get_current_time(lua_State* L);
int lgob_time_val_free(lua_State* L);
int lgob_time_val_new(lua_State* L);
int lgob_time_val_add(lua_State* L);

int lgob_timer_free(lua_State* L);
int lgob_timer_new(lua_State* L);
int lgob_timer_start(lua_State* L);
int lgob_timer_stop(lua_State* L);
int lgob_timer_continue(lua_State* L);
int lgob_timer_elapsed(lua_State* L);

int lgob_utf8_validate(lua_State* L);
int lgob_utf8_strup(lua_State* L);
int lgob_utf8_strdown(lua_State* L);
int lgob_utf8_casefold(lua_State* L);
int lgob_utf8_normalize(lua_State* L);
int lgob_utf8_strlen(lua_State* L);
int lgob_utf8_collate(lua_State* L);
int lgob_utf8_collate_key(lua_State* L);
int lgob_utf8_from_filename(lua_State* L);
int lgob_utf8_to_filename(lua_State* L);
int lgob_convert(lua_State* L);
int lgob_get_charset(lua_State* L);

int lgob_thread_init(lua_State* L);
