/*
	This file is part of lgob.

	lgob is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgob is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgob.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2009 Lucas Hermann Negri
*/

#ifndef lgob_OBJECT
#define lgob_OBJECT

#include "lgob.h"
#include "boxed.h"
#include <gobject/gvaluecollector.h>

/* Library functions, for intenal use */

gboolean priv_object_new(lua_State* L, GObject* object, gboolean need_unref);
gboolean priv_struct_new(lua_State* L, gpointer object, gboolean need_unref);
guint priv_idle_add(gint priority, Data* userdata);
guint priv_timeout_add(gint priority, guint interval, Data* userdata);

/* Value handling */

int lgob_value_push(lua_State* L);
int lgob_value_set(lua_State* L);

/* Object */

int lgob_object_get(lua_State* L);
int lgob_object_set(lua_State* L);
int lgob_object_connect(lua_State* L);
int lgob_object_block(lua_State* L);
int lgob_object_unblock(lua_State* L);
int lgob_object_disconnect(lua_State* L);
int lgob_object_unref(lua_State* L);
int lgob_object_ref(lua_State* L);
int lgob_object_notify(lua_State* L);
int lgob_object_thaw_notify(lua_State* L);
int lgob_object_freeze_notify(lua_State* L);
int lgob_object_cast(lua_State* L);

/* Struct */

int lgob_struct_new(lua_State *L);
int lgob_struct_to_string(lua_State* L);
int lgob_struct_gc(lua_State* L);

/* Used by other libraries, communicating via the Lua stack */

int lgob_object_new(lua_State *L);
int lgob_object_eq(lua_State* L);
int lgob_object_gc(lua_State* L);
int lgob_closure_new(lua_State* L);
int lgob_object_to_string(lua_State* L);

#endif
